// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {


    startPoint: any;
    rigidBody: any;
    tween: any;
    startCollision: boolean = false;
    points: any = [];
    nodePos: cc.Vec2;
    dir: cc.Vec3;

    // LIFE-CYCLE CALLBACKS:
    onPreSolve(contact, selfCollider, otherCollider) {
        if (otherCollider.node.name.includes('disk')) {
            // this.moveEnd();
            this.startCollision = true;
            this.scheduleOnce(()=>{
                this.rigidBody.type = cc.RigidBodyType.Dynamic;
                otherCollider.node.getComponent(cc.RigidBody).type = cc.RigidBodyType.Kinematic;
                let joint = this.node.addComponent(cc.WeldJoint);
                joint.connectedAnchor = cc.v2(-51.8, 0.4);
                joint.connectedBody = otherCollider.node.getComponent(cc.RigidBody);
            }, 0);
            // joint.anchor = cc.v2(-51.7, -1.1);
        }
        }

        onPostSolve(contact, selfCollider, otherCollider) {
            // this.schedule(()=>{
            //     this.rigidBody.type = cc.RigidBodyType.Kinematic;
            //     otherCollider.node.getComponent(cc.RigidBody).type = cc.RigidBodyType.Dynamic;
            // },0);
        }

    onLoad () {
        this.dir = cc.v3(this.node.position.x, this.node.position.y, 0);
        this.rigidBody = this.node.getComponent(cc.RigidBody);
        this.rigidBody.type = cc.RigidBodyType.Kinematic;
        this.initEvent();
    }

    initEvent() {
        this.node.on(cc.Node.EventType.TOUCH_START, this._touchStartEvent, this);
        this.node.on(cc.Node.EventType.TOUCH_MOVE, this._touchMoveEvent, this);
        this.node.on(cc.Node.EventType.TOUCH_END, this._touchEndEvent, this);
        this.node.on(cc.Node.EventType.TOUCH_CANCEL, this._touchCancelEvent, this);
    }

    _touchStartEvent(event: cc.Event.EventTouch) {
        // this.startPoint = event.getStartLocation();
    }
    _touchMoveEvent(event: cc.Event.EventTouch) {
        var touches = event.getTouches();
        let newPos = this.node.parent.convertToNodeSpaceAR(touches[0].getLocation());
        // let subPos = oldPos.sub(newPos);
        // let dir = cc.v3(this.nodePos.x - subPos.x, this.nodePos.y - subPos.y, 0);
        this.dir = cc.v3(newPos.x, newPos.y, 0);
        // this.move(dir);
    }

    _touchEndEvent(event: cc.Event.EventTouch) {
        // this.points = [];
        // clientEvent.dispatchEvent('moveEnd');
    }

    _touchCancelEvent(event: cc.Event.EventTouch) {
        // clientEvent.dispatchEvent('moveEnd');
        this.moveEnd();
    }

    move(dir) {
    }
    moveEnd() {
    }

    start () {

    }

    update (dt) {
        const oldPos = cc.v3 (this.node.position.x, this.node.position.y, 0);
        let targetPos = this.dir.clone();
        let subPos = targetPos.sub(oldPos);
        let distance = subPos.mag();
        if (distance > 100) {
            targetPos =  oldPos.clone().add(targetPos.sub(oldPos.clone()).normalizeSelf().mul(100));
        }
        this.node.position = this.node.position.clone().lerp(targetPos, 4*dt);
        
    }
}
